//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
//

/*
 * CompressLZMH.h
 *
 * This Code is under the GNU Lesser General Public License.
 * 
 *  Created on: 28.09.2011
 *      Author: Martin Ringwelski
 */

#ifndef COMPRESSLZMH_H_
#define COMPRESSLZMH_H_

#include <sys/types.h>

#define DECOMPRESSOR

#ifndef LZ_MAX_OFFSET
#define LZ_MAX_OFFSET	128			// More than 128 breaks the code
#endif

#ifndef LZ_MAX_LENGTH
#define LZ_MAX_LENGTH	274			// More than 274 breaks the code
#endif

#ifndef HUFF_BYTE_LENGTH
#define HUFF_BYTE_LENGTH	8		// Length of a byte in bit. As we are only
									// using ASCII Codes 7 bit are enough.
#endif

#ifndef HUFF_LIST_LENGTH
#define HUFF_LIST_LENGTH	48		// here should only be 31 symbols, but in
									// the future there may be more, so I set
									// it to 48.
#endif

#ifndef INTERN_BUFFER_LENGTH
#define INTERN_BUFFER_LENGTH	160	// Before overwriting the input data, the
									// compressed data is stored in a buffer.
									// Needs to be at least LZ_MAX_OFFSET + 1.
#endif

size_t Compress(uint8_t* buffer, size_t insize);
#ifndef NODECOMPRESSOR
size_t DeCompress(uint8_t* inbuffer, size_t insize, uint8_t* outbuffer, size_t outsize = 0xFFFF);
#endif

#endif /* COMPRESSLZMH_H_ */
